/*
 * RGB_ledblink2
 * Sorban léptetjük 0 és 7 között az RGB LED színkódjait, melynek
 * értelmezése: 0. bit = piros, 1. bit = zöld 2. bit = kék alapszín.
 * Mindegyik színkombináció 2 másodpercig világít, utána tovább lépünk.
 * A 0 színkód azt jelenti, hogy kikapcsolva hagyjuk az összes alapszínt (fekete).
 *
 * Hardver követelmények: Arduino kártya, közös katódú RGB LED a 
 * D3, D5, D6 kivezetésekre kötve
 */
#define LED_RED    3             // Piros LED
#define LED_ANODE  4             // Közös anód esetén
#define LED_GREEN  5             // Zöld LED
#define LED_BLUE   6             // Kék LED

int color = 1;

void setup() {                
  // Kimenetként inicialzáljuk a LED vezérlő lábakat
  pinMode(LED_RED, OUTPUT);     
  pinMode(LED_ANODE, OUTPUT);    // Közös anód esetén     
  pinMode(LED_BLUE, OUTPUT);     
  pinMode(LED_GREEN, OUTPUT);    
  digitalWrite(LED_ANODE,HIGH);  // Közös anód esetén  
}

void loop() {
  digitalWrite(LED_RED, !bitRead(color,0));   // piros LED beállítása
  digitalWrite(LED_GREEN,!bitRead(color,1));  // zöld LED ki
  digitalWrite(LED_BLUE,!bitRead(color,2));   // kék LED ki
  delay(2000);                                // várunk 2 másodpercig 
  color = ++color & 0x07; 
}
