﻿/* RGB_ledswitch
 *
 * Nyomógombbal sorban léptetjük 0 és 7 között az RGB LED színkódjait, melynek
 * értelmezése: 0. bit = piros, 1. bit = zöld 2. bit = kék alapszín.
 * A 0 színkód azt jelenti, hogy kikapcsolva hagyjuk az összes alapszínt (fekete).
 *
 * Hardver követelmények: Arduino kártya, közös anódú RGB LED a
 * D3, D4, D5, D6 kivezetésekre kötve, nyomógomb D2 és a föld közé kötve
 * (D3 = RED, D4 = ANODE, D5 = GREEN, D6 = BLUE)
 */
#define LED_RED    3             // Piros LED
#define LED_ANODE  4             // Közös anód esetén
#define LED_GREEN  5             // Zöld LED
#define LED_BLUE   6             // Kék LED
#define PUSH2      2             // Nyomógomb

int color = 0;                   //színkód (0..7)
boolean waitforpress = true;

void setup() {
  // Kimenetként inicialzáljuk a LED vezérlő lábakat
  pinMode(LED_RED, OUTPUT);
  pinMode(LED_ANODE, OUTPUT);    // Közös anód esetén
  pinMode(LED_BLUE, OUTPUT);
  pinMode(LED_GREEN, OUTPUT);
  digitalWrite(LED_ANODE, HIGH); // Közös anód esetén
  // A nyomógombot fogadó láb legyen bemenet, belső felhúzással
  pinMode(PUSH2, INPUT_PULLUP);
}

void loop() {
  if (waitforpress) {            //Ha lenyomásra várunk és
    if (!digitalRead(PUSH2)) {   //Ha lenyomás történt...
      color = ++color & 0x07;    //Szín léptetése
      waitforpress = false;      //Következő stáció: felengedésre várunk
    }
  }
  else {                         //Ha felengedésre vártunk és
    if (digitalRead(PUSH2)) {    //Ha felengedést észlelünk...
      waitforpress = true;       //Következő stáció: lenyomásra várunk
    }
  }
  digitalWrite(LED_RED, !bitRead(color, 0));   // piros LED beállítása
  digitalWrite(LED_GREEN, !bitRead(color, 1)); // zöld LED beállítása
  digitalWrite(LED_BLUE, !bitRead(color, 2));  // kék LED beállítása
  delay(20);                    //pergésmentesítő késleltetés
}
